<?php
namespace Ep\Gath\Plugin;

/**
 * Class GathPluginBridge
 *
 * @package Ep\Gath\Plugin
 * @author Elektronika Perhoč <web@ep.hr>
 * @link http://gitlab.ep.local/ep-framework/gath
 */
trait GathPluginBridge
{
    /** @var Prices */
    protected $gathPrices;
    /** @var Products */
    protected $gathProducts;
    /** @var Stock */
    protected $gathStock;

    /**
     * @return Prices
     */
    protected function getGathPrices(): Prices
    {
        if (null === $this->gathPrices) {
            $this->gathPrices = apply_filters('ep_gath_prices', null);
        }

        return $this->gathPrices;
    }

    /**
     * @return Products
     */
    protected function getGathProducts(): Products
    {
        if (null === $this->gathProducts) {
            $this->gathProducts = apply_filters('ep_gath_products', null);
        }

        return $this->gathProducts;
    }

    /**
     * @return Stock
     */
    protected function getGathStock(): Stock
    {
        if (null === $this->gathStock) {
            $this->gathStock = apply_filters('ep_gath_stock', null);
        }

        return $this->gathStock;
    }
}